/*
 * Copyright (c) Developers of JTowers
 * Redistributable and modifiable. Please see license.readme for details.
 *
 * ammendment history
 * <date>			<changed by>		<summary of changes>
 * 18 August 2004	Jonee Ryan Ty		First documented history
 *
 */

import java.util.EmptyStackException;


class StackNode			
{
	private Object data;
	private StackNode next;		
	
	/**
	*@param data object of this node
	*/
		
	public StackNode(Object o)
	{
		data = o;
		next = null;
	}
	
	/**
	*@param data object and next Stacknode
	*/
		
	public StackNode(Object o, StackNode next)
	{
		data = o;
		this.next = next;
	}
		
	/**
	*@return data of this node
	*/
		
	public Object getData()
	{
		return data;
	}
		
	/**
	*@return the next node to this node
	*/
		
	public StackNode getNext()
	{
		return next;
	}
	
} // end of StackNode class
	

public class MyStack		implements Stack
{
	private StackNode top;
	
	private int	size = 0; // number of current elements the stack has
	
	public int size()
	{
		return size;
	}
	
	public boolean isEmpty()
	{
		return (size == 0);
	}
	
	public Object top()		throws EmptyStackException
	{
		if(isEmpty())
			throw new EmptyStackException();
			
		return top;
	}
	
	public void push(Object obj)		
	{		
		if(isEmpty())
			top = new StackNode(obj);
		
		else
			top = new StackNode(obj, top);
		
		size++;
	}
	
	public Object pop()		throws EmptyStackException
	{
		if(isEmpty())
			throw new EmptyStackException();
	
		StackNode remove = top;
		Object removeItem = top.getData();
		
		top = top.getNext();
				
		size--;
		
		return removeItem;
	}
		
} // end of MyStack
