/*
 * Copyright (c) Developers of JTowers
 * Redistributable and modifiable. Please see license.readme for details.
 *
 * ammendment history
 * <date>			<changed by>		<summary of changes>
 * 18 August 2004	Jonee Ryan Ty		First documented history
 *
 */

import java.util.EmptyStackException;

/**
 *"wrapper" class that basically echoes stack methods
 */

	 
class Peg		
{
	private Stack disks;		
	
	public static final int WIDTH = 150,	
							HEIGHT = 227;
							
	private int x, y,	// upper left coordinate
				midX,	// x- coordinate of center of peg 	
				baseY;	// y - coordinate of floor of peg
	
	private String name;											
	
	public Peg(int x, int y, String name)
	{	
		this.x = x;
		this.y = y;
		this.name = name;
			
		midX = x + Peg.WIDTH / 2;
		baseY = y + Peg.HEIGHT;
			
		disks = StackFactory.createStack();	
	}
		
	/**
	 *@return the upper left x-coordinate
	 */
		 	
	public int getX()
	{
		return x;
	}
		
	/**
	 *@return the upper left y-coordinate
	 */
		 
	public int getY()
	{
		return y;
	}
		
	/**
	 *@return the center x-coordinate of this peg
	 */
		 
	public int getMidX()
	{
		return midX;
	}
		
	/**
	 *@return "floor" of this peg
	 */
		 
	public int getBaseY()
	{
		return baseY;
	}
		
	/**
	 *@return the top disk element without popping
	 */
	
	public Disk top()		throws EmptyStackException
	{
		return (Disk)(((StackNode)(disks.top())).getData());
	}
		
	/**
	 *@return the top StackNode of stack without popping
	 */
		 
	public StackNode getTopStackNode()
	{
	 	return (StackNode)(disks.top());
	}
		
	/**
	 *@return the number of current elements this peg has
	 */
		 
	public int size()
	{
		return disks.size();
	}
			
	/**
	 *pushes a disk into this peg
	 */
		 	
	public void push(Disk d)		
	{	
		disks.push(d);
	}
	
	/**
	 *pops a disk from stack
	 */
		 
	public Disk pop()		throws EmptyStackException
	{
		return (Disk)(disks.pop());
	}

	public String getName() {
		return name;
	}
	
}//##30
