/*
 * Copyright (c) Developers of JTowers
 * Redistributable and modifiable. Please see license.readme for details.
 *
 * ammendment history
 * <date>			<changed by>		<summary of changes>
 * 18 August 2004	Jonee Ryan Ty		First documented history
 *
 */

import java.util.EmptyStackException;

/**
 *stack interface definition
 */

public interface Stack
{
	
	/**
	*@return number of elements in the stack
	*/
	
	public int size();
	
	/**
	*@return true if the stack is empty, false otherwise
	*/
	
	public boolean isEmpty();
	
	/**
	*@return top element in the stack AS A StackNode
	*@exception EmptyStackException if the stack is empty
	*/
	
	public Object top()		throws EmptyStackException;
	
	/**
	*insert an element at the top of the stack
	*@param element to be inserted
	*/
	
	public void push(Object obj);
	
	/**
	*remove the top element from the stack
	*@return element removed
	*@exception EmptyStackException if the stack is empty
	*/
	
	public Object pop()		throws EmptyStackException;
	
} //##30	
